Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 128)
@@ -279,148 +346,175 @@
 #endif
 
-#define ALLOC1_INTERFACE_END(x1)                \
-  delete [] interface;
+#define ALLOC1_INTERFACE_END(x1)                                        \
+  do                                                                    \
+    {                                                                   \
+      delete [] interface;                                              \
+    } while (0)
 
 #define ALLOC1_VAL_ACK_IN( sig, name, type)                             \
-  {                                                                     \
-    sig = new SC_IN (Tcontrol_t) * [iterator_1];                        \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        sig [it1] = interface[it1]->set_signal_valack_in (name, type);  \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (Tcontrol_t) * [iterator_1];                      \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          sig [it1] = interface[it1]->set_signal_valack_in (name, type); \
+        }                                                               \
+    } while (0)
+
 #define ALLOC1_VAL_ACK_OUT(sig, name, type)                             \
-  {                                                                     \
-    sig = new SC_OUT(Tcontrol_t) * [iterator_1];                        \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        sig [it1] = interface[it1]->set_signal_valack_out(name, type);  \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT(Tcontrol_t) * [iterator_1];                      \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          sig [it1] = interface[it1]->set_signal_valack_out(name, type); \
+        }                                                               \
+    } while (0)
+
 #define ALLOC1_VALACK_IN(    sig, type)                                 \
-  {                                                                     \
-    sig = new SC_IN (Tcontrol_t) * [iterator_1];                        \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        sig [it1] = interface[it1]->set_signal_valack_in (type);        \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (Tcontrol_t) * [iterator_1];                      \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          sig [it1] = interface[it1]->set_signal_valack_in (type);      \
+        }                                                               \
+    } while (0)
+
 #define ALLOC1_VALACK_OUT(   sig, type)                                 \
-  {                                                                     \
-    sig = new SC_OUT(Tcontrol_t) * [iterator_1];                        \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        sig [it1] = interface[it1]->set_signal_valack_out(type);        \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT(Tcontrol_t) * [iterator_1];                      \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          sig [it1] = interface[it1]->set_signal_valack_out(type);      \
+        }                                                               \
+    } while (0)
+
 #define ALLOC1_SIGNAL_IN( sig, name, type, size)                        \
-  {                                                                     \
-    sig = new SC_IN (type) * [iterator_1];                              \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) * [iterator_1];                            \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          if (size > 0)                                                 \
+            {                                                           \
+              sig [it1] = interface[it1]->set_signal_in <type> (name, size); \
+            }                                                           \
+          else                                                          \
+            {                                                           \
+              PRINT_SIZE_NUL(_component,interface[it1],name);           \
+            }                                                           \
+        }                                                               \
+    } while (0)
+
+#define ALLOC1_SIGNAL_OUT(sig, name, type, size)                        \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT(type) * [iterator_1];                            \
+      for (uint32_t it1=0; it1<iterator_1; it1++)                       \
+        {                                                               \
+          if (size > 0)                                                 \
+            {                                                           \
+              sig [it1] = interface[it1]->set_signal_out<type> (name, size); \
+            }                                                           \
+          else                                                          \
+            {                                                           \
+              PRINT_SIZE_NUL(_component,interface[it1],name);           \
+            }                                                           \
+        }                                                               \
+    } while (0)
+
+#define DELETE1_SIGNAL(sig, x1, size)                                   \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          if (size > 0)                                                 \
+            {                                                           \
+              delete sig[it1];                                          \
+            }                                                           \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
+
+#define ALLOC1_FOREIGN_SIGNAL_IN(sig, interface, name, type, size,x1)   \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) * [x1];                                    \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
         if (size > 0)                                                   \
           {                                                             \
-            sig [it1] = interface[it1]->set_signal_in <type> (name, size); \
+            std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(name)); \
+            sig [it1] = new SC_IN (type) (str.c_str());                 \
           }                                                             \
-        else                                                            \
+    } while (0)
+
+#define ALLOC1_FOREIGN_SIGNAL_OUT(sig, interface, name, type, size,x1)  \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (type) * [x1];                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        if (size > 0)                                                   \
           {                                                             \
-            PRINT_SIZE_NUL(_component,interface[it1],name);             \
+            std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(name)); \
+            sig [it1] = new SC_OUT (type) (str.c_str());                \
+          }                                                             \
+    } while (0)
+
+#define DELETE1_FOREIGN_SIGNAL( sig, size,x1)                           \
+  do                                                                    \
+    {                                                                   \
+      DELETE1_SIGNAL(sig,x1,size);                                      \
+    } while (0)
+
+#define ALLOC1_SC_SIGNAL( sig, name, type, x1)                          \
+  do                                                                    \
+    {                                                                   \
+      sig = new sc_signal<type> * [x1];                                 \
+      {                                                                 \
+        std::string separator="_";                                      \
+        std::string str;                                                \
+        for (uint32_t it1=0; it1<x1; it1++)                             \
+          {                                                             \
+            str = name+separator+toString(it1);                         \
+            sig [it1] = new sc_signal<type> (str.c_str());              \
+            PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1]);                 \
           }                                                             \
       }                                                                 \
-  }
-
-#define ALLOC1_SIGNAL_OUT(sig, name, type, size)                        \
-  {                                                                     \
-    sig = new SC_OUT(type) * [iterator_1];                              \
-    for (uint32_t it1=0; it1<iterator_1; it1++)                         \
-      {                                                                 \
-        if (size > 0)                                                   \
-          {                                                             \
-            sig [it1] = interface[it1]->set_signal_out<type> (name, size); \
-          }                                                             \
-        else                                                            \
-          {                                                             \
-            PRINT_SIZE_NUL(_component,interface[it1],name);             \
-          }                                                             \
-      }                                                                 \
-  }
-
-#define DELETE1_SIGNAL(sig, x1, size)                                   \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        if (size > 0)                                                   \
-          {                                                             \
-            delete sig[it1];                                            \
-          }                                                             \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
-
-#define ALLOC1_FOREIGN_SIGNAL_IN(sig, interface, name, type, size,x1)   \
-  {                                                                     \
-    sig = new SC_IN (type) * [x1];                                   \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      if (size > 0)                                                     \
-        {                                                               \
-          std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(name)); \
-          sig [it1] = new SC_IN (type) (str.c_str());                   \
-        }                                                               \
-  }
-
-#define ALLOC1_FOREIGN_SIGNAL_OUT(sig, interface, name, type, size,x1)  \
-  {                                                                     \
-    sig = new SC_OUT (type) * [x1];                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      if (size > 0)                                                     \
-        {                                                               \
-          std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(name)); \
-          sig [it1] = new SC_OUT (type) (str.c_str());                  \
-        }                                                               \
-  }
-
-#define DELETE1_FOREIGN_SIGNAL( sig, size,x1)            \
-  {                                                      \
-    DELETE1_SIGNAL(sig,x1,size);                         \
-  }
-
-#define ALLOC1_SC_SIGNAL( sig, name, type, x1)                          \
-  sig = new sc_signal<type> * [x1];                                     \
-  {                                                                     \
-    std::string separator="_";                                          \
-    std::string str;                                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        str = name+separator+toString(it1);                             \
-        sig [it1] = new sc_signal<type> (str.c_str());                  \
-        PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1]);                     \
-      }                                                                 \
-  }
-
-#define INSTANCE1_SC_SIGNAL(component, sig, x1) \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    {                                                                   \
-      TEST_SIGNAL(component->sig [it1]->name(),component->sig [it1]);   \
-      TEST_SIGNAL(sig            [it1]->name(),sig            [it1]);   \
-      (*(component->sig[it1])) (*(sig[it1]));                           \
-    }
-
-#define _INSTANCE1_SC_SIGNAL(component, sig1, sig2, x1) \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    {                                                                   \
-      TEST_SIGNAL(component->sig1 [it1]->name(),component->sig1 [it1]); \
-      TEST_SIGNAL(sig2            [it1]->name(),sig2            [it1]); \
-      (*(component->sig1[it1])) (*(sig2[it1]));                         \
-    }
+    } while (0)
+
+#define INSTANCE1_SC_SIGNAL(component, sig, x1)                         \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          TEST_SIGNAL(component->sig [it1]->name(),component->sig [it1]); \
+          TEST_SIGNAL(sig            [it1]->name(),sig            [it1]); \
+          (*(component->sig[it1])) (*(sig[it1]));                       \
+        }                                                               \
+    } while (0)
+
+#define _INSTANCE1_SC_SIGNAL(component, sig1, sig2, x1)                 \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          TEST_SIGNAL(component->sig1 [it1]->name(),component->sig1 [it1]); \
+          TEST_SIGNAL(sig2            [it1]->name(),sig2            [it1]); \
+          (*(component->sig1[it1])) (*(sig2[it1]));                     \
+        }                                                               \
+    } while (0)
 
 #define DELETE1_SC_SIGNAL(sig, x1)                                      \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        PRINT_SIGNAL_ADDRESS("",sig[it1]);                         \
-        delete sig[it1];                                                \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          PRINT_SIGNAL_ADDRESS("",sig[it1]);                            \
+          delete sig[it1];                                              \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
 
 // ----------------------------------------------------------------------
@@ -429,5 +523,5 @@
 
 #ifdef POSITION
-#define ALLOC2_INTERFACE_BEGIN( name, direction, localisation, str, x1, x2)   \
+#define ALLOC2_INTERFACE_BEGIN( name, direction, localisation, str, x1, x2) \
   INTERFACE_PRINT(name);                                                \
   uint32_t iterator_1 = 0;                                              \
@@ -449,5 +543,5 @@
   }
 #else
-#define ALLOC2_INTERFACE_BEGIN( name, direction, localisation, str, x1, x2)   \
+#define ALLOC2_INTERFACE_BEGIN( name, direction, localisation, str, x1, x2) \
   INTERFACE_PRINT(name);                                                \
   uint32_t iterator_1 = 0;                                              \
